[PATCH] libmakepkg: Add basic rules to lint makepkg.conf variables

classic Classic list List threaded Threaded
7 messages Options
Reply | Threaded
Open this post in threaded view
|

[PATCH] libmakepkg: Add basic rules to lint makepkg.conf variables

Eli Schwartz-2
Currently the only things we check are:

- Things that should be arrays, are not strings, and vice versa (this
  was mostly copy-pasted from the similar code in lint_pkgbuild).
- Variables that are meant to contain pathname components cannot contain
  a newline character, because newline characters in pathnames are weird
  and also don't play well with future changes intended for the
  --packagelist option.

Signed-off-by: Eli Schwartz <[hidden email]>
---
 scripts/Makefile.am                           |  4 ++
 scripts/libmakepkg/lint_config.sh.in          | 48 ++++++++++++++++++++
 scripts/libmakepkg/lint_config/paths.sh.in    | 47 ++++++++++++++++++++
 scripts/libmakepkg/lint_config/variable.sh.in | 64 +++++++++++++++++++++++++++
 scripts/makepkg.sh.in                         |  4 ++
 5 files changed, 167 insertions(+)
 create mode 100755 scripts/libmakepkg/lint_config.sh.in
 create mode 100644 scripts/libmakepkg/lint_config/paths.sh.in
 create mode 100644 scripts/libmakepkg/lint_config/variable.sh.in

diff --git a/scripts/Makefile.am b/scripts/Makefile.am
index 8cf79f21..90593984 100644
--- a/scripts/Makefile.am
+++ b/scripts/Makefile.am
@@ -44,6 +44,7 @@ libmakepkgdir = $(datarootdir)/makepkg
 
 LIBMAKEPKGDIRS = \
  integrity \
+ lint_config \
  lint_package \
  lint_pkgbuild \
  source \
@@ -56,6 +57,9 @@ LIBMAKEPKG_IN = \
  libmakepkg/integrity/generate_signature.sh \
  libmakepkg/integrity/verify_checksum.sh \
  libmakepkg/integrity/verify_signature.sh \
+ libmakepkg/lint_config.sh \
+ libmakepkg/lint_config/paths.sh \
+ libmakepkg/lint_config/variables.sh \
  libmakepkg/lint_package.sh \
  libmakepkg/lint_package/build_references.sh \
  libmakepkg/lint_package/dotfiles.sh \
diff --git a/scripts/libmakepkg/lint_config.sh.in b/scripts/libmakepkg/lint_config.sh.in
new file mode 100755
index 00000000..b383a910
--- /dev/null
+++ b/scripts/libmakepkg/lint_config.sh.in
@@ -0,0 +1,48 @@
+#!/usr/bin/bash
+#
+#   lint_config.sh - functions for checking for makepkg.conf errors
+#
+#   Copyright (c) 2018 Pacman Development Team <[hidden email]>
+#
+#   This program is free software; you can redistribute it and/or modify
+#   it under the terms of the GNU General Public License as published by
+#   the Free Software Foundation; either version 2 of the License, or
+#   (at your option) any later version.
+#
+#   This program is distributed in the hope that it will be useful,
+#   but WITHOUT ANY WARRANTY; without even the implied warranty of
+#   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+#   GNU General Public License for more details.
+#
+#   You should have received a copy of the GNU General Public License
+#   along with this program.  If not, see <http://www.gnu.org/licenses/>.
+#
+
+[[ -n "$LIBMAKEPKG_LINT_CONFIG_SH" ]] && return
+LIBMAKEPKG_LINT_CONFIG_SH=1
+
+LIBRARY=${LIBRARY:-'/usr/share/makepkg'}
+
+source "$LIBRARY/util/message.sh"
+source "$LIBRARY/util/util.sh"
+
+
+declare -a lint_config_functions
+
+for lib in "$LIBRARY/lint_config/"*.sh; do
+ source "$lib"
+done
+
+readonly -a lint_config_functions
+
+
+lint_package() {
+ cd_safe "$pkgdir"
+ msg "$(gettext "Checking for makepkg.conf issues...")"
+
+ local ret=0
+ for func in ${lint_config_functions[@]}; do
+ $func || ret=1
+ done
+ return $ret
+}
diff --git a/scripts/libmakepkg/lint_config/paths.sh.in b/scripts/libmakepkg/lint_config/paths.sh.in
new file mode 100644
index 00000000..36b090b4
--- /dev/null
+++ b/scripts/libmakepkg/lint_config/paths.sh.in
@@ -0,0 +1,47 @@
+#!/bin/bash
+#
+#   paths.sh - Check that pathname components do not contain odd characters
+#
+#   Copyright (c) 2018 Pacman Development Team <[hidden email]>
+#
+#   This program is free software; you can redistribute it and/or modify
+#   it under the terms of the GNU General Public License as published by
+#   the Free Software Foundation; either version 2 of the License, or
+#   (at your option) any later version.
+#
+#   This program is distributed in the hope that it will be useful,
+#   but WITHOUT ANY WARRANTY; without even the implied warranty of
+#   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+#   GNU General Public License for more details.
+#
+#   You should have received a copy of the GNU General Public License
+#   along with this program.  If not, see <http://www.gnu.org/licenses/>.
+#
+
+[[ -n "$LIBMAKEPKG_LINT_CONFIG_PATHS_SH" ]] && return
+LIBMAKEPKG_LINT_CONFIG_PATHS_SH=1
+
+LIBRARY=${LIBRARY:-'@libmakepkgdir@'}
+
+source "$LIBRARY/util/message.sh"
+source "$LIBRARY/util/pkgbuild.sh"
+
+lint_config_functions+=('lint_variable')
+
+
+lint_paths() {
+ local pathvars=(BUILDDIR PKGDEST SRCDEST SRCPKGDEST LOGDEST PKGEXT SRCEXT)
+
+ local  ret=0
+
+ # global variables
+ for i in ${pathvars[@]}; do
+ if [[ ${!i} = *$'\n'* ]]; then
+ error "$(gettext "%s contains invalid characters: '%s'")" \
+ "$i" "${!i//[^$'\n']}"
+ ret=1
+ fi
+ done
+
+ return $ret
+}
diff --git a/scripts/libmakepkg/lint_config/variable.sh.in b/scripts/libmakepkg/lint_config/variable.sh.in
new file mode 100644
index 00000000..14bd0e05
--- /dev/null
+++ b/scripts/libmakepkg/lint_config/variable.sh.in
@@ -0,0 +1,64 @@
+#!/bin/bash
+#
+#   variable.sh - Check that variables are or are not arrays as appropriate
+#
+#   Copyright (c) 2018 Pacman Development Team <[hidden email]>
+#
+#   This program is free software; you can redistribute it and/or modify
+#   it under the terms of the GNU General Public License as published by
+#   the Free Software Foundation; either version 2 of the License, or
+#   (at your option) any later version.
+#
+#   This program is distributed in the hope that it will be useful,
+#   but WITHOUT ANY WARRANTY; without even the implied warranty of
+#   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+#   GNU General Public License for more details.
+#
+#   You should have received a copy of the GNU General Public License
+#   along with this program.  If not, see <http://www.gnu.org/licenses/>.
+#
+
+[[ -n "$LIBMAKEPKG_LINT_CONFIG_VARIABLE_SH" ]] && return
+LIBMAKEPKG_LINT_CONFIG_VARIABLE_SH=1
+
+LIBRARY=${LIBRARY:-'@libmakepkgdir@'}
+
+source "$LIBRARY/util/message.sh"
+
+lint_config_functions+=('lint_variable')
+
+
+lint_variable() {
+ local array=(DLAGENTS VCSCLIENTS BUILDENV OPTIONS INTEGRITY_CHECK MAN_DIRS
+             DOC_DIRS PURGE_TARGETS COMPRESSGZ COMPRESSBZ2 COMPRESSXZ
+             COMPRESSLRZ COMPRESSLZO COMPRESSZ)
+ local string=(CARCH CHOST CPPFLAGS CFLAGS CXXFLAGS LDFLAGS DEBUG_CFLAGS
+              DEBUG_CXXFLAGS DISTCC_HOSTS BUILDDIR STRIP_BINARIES STRIP_SHARED
+              STRIP_STATIC PKGDEST SRCDEST SRCPKGDEST LOGDEST PACKAGER GPGKEY
+              PKGEXT SRCEXT)
+
+ local i keys ret=0
+
+ # global variables
+ for i in ${array[@]}; do
+ eval "keys=(\"\${!$i[@]}\")"
+ if (( ${#keys[*]} > 0 )); then
+ if ! is_array $i; then
+ error "$(gettext "%s should be an array")" "$i"
+ ret=1
+ fi
+ fi
+ done
+
+ for i in ${string[@]}; do
+ eval "keys=(\"\${!$i[@]}\")"
+ if (( ${#keys[*]} > 0 )); then
+ if is_array $i; then
+ error "$(gettext "%s should not be an array")" "$i"
+ ret=1
+ fi
+ fi
+ done
+
+ return $ret
+}
diff --git a/scripts/makepkg.sh.in b/scripts/makepkg.sh.in
index a22bcce2..f0703d41 100644
--- a/scripts/makepkg.sh.in
+++ b/scripts/makepkg.sh.in
@@ -1361,6 +1361,10 @@ else
 fi
 
 
+# check makepkg.conf for some basic requirements
+lint_config || exit $E_CONFIG_ERROR
+
+
 # check that all settings directories are user-writable
 if ! ensure_writable_dir "BUILDDIR" "$BUILDDIR"; then
  plain "$(gettext "Aborting...")"
--
2.16.1
Reply | Threaded
Open this post in threaded view
|

Re: [PATCH] libmakepkg: Add basic rules to lint makepkg.conf variables

Allan McRae
On 08/02/18 14:44, Eli Schwartz wrote:

> Currently the only things we check are:
>
> - Things that should be arrays, are not strings, and vice versa (this
>   was mostly copy-pasted from the similar code in lint_pkgbuild).
> - Variables that are meant to contain pathname components cannot contain
>   a newline character, because newline characters in pathnames are weird
>   and also don't play well with future changes intended for the
>   --packagelist option.
>
> Signed-off-by: Eli Schwartz <[hidden email]>
> ---
>  scripts/Makefile.am                           |  4 ++
>  scripts/libmakepkg/lint_config.sh.in          | 48 ++++++++++++++++++++
>  scripts/libmakepkg/lint_config/paths.sh.in    | 47 ++++++++++++++++++++
>  scripts/libmakepkg/lint_config/variable.sh.in | 64 +++++++++++++++++++++++++++
>  scripts/makepkg.sh.in                         |  4 ++
>  5 files changed, 167 insertions(+)
>  create mode 100755 scripts/libmakepkg/lint_config.sh.in
>  create mode 100644 scripts/libmakepkg/lint_config/paths.sh.in
>  create mode 100644 scripts/libmakepkg/lint_config/variable.sh.in
>
> diff --git a/scripts/Makefile.am b/scripts/Makefile.am
> index 8cf79f21..90593984 100644
> --- a/scripts/Makefile.am
> +++ b/scripts/Makefile.am
> @@ -44,6 +44,7 @@ libmakepkgdir = $(datarootdir)/makepkg
>  
>  LIBMAKEPKGDIRS = \
>   integrity \
> + lint_config \
>   lint_package \
>   lint_pkgbuild \
>   source \
> @@ -56,6 +57,9 @@ LIBMAKEPKG_IN = \
>   libmakepkg/integrity/generate_signature.sh \
>   libmakepkg/integrity/verify_checksum.sh \
>   libmakepkg/integrity/verify_signature.sh \
> + libmakepkg/lint_config.sh \
> + libmakepkg/lint_config/paths.sh \
> + libmakepkg/lint_config/variables.sh \
>   libmakepkg/lint_package.sh \
>   libmakepkg/lint_package/build_references.sh \
>   libmakepkg/lint_package/dotfiles.sh \
> diff --git a/scripts/libmakepkg/lint_config.sh.in b/scripts/libmakepkg/lint_config.sh.in
> new file mode 100755
> index 00000000..b383a910
> --- /dev/null
> +++ b/scripts/libmakepkg/lint_config.sh.in
> @@ -0,0 +1,48 @@
> +#!/usr/bin/bash
> +#
> +#   lint_config.sh - functions for checking for makepkg.conf errors
> +#
> +#   Copyright (c) 2018 Pacman Development Team <[hidden email]>
> +#
> +#   This program is free software; you can redistribute it and/or modify
> +#   it under the terms of the GNU General Public License as published by
> +#   the Free Software Foundation; either version 2 of the License, or
> +#   (at your option) any later version.
> +#
> +#   This program is distributed in the hope that it will be useful,
> +#   but WITHOUT ANY WARRANTY; without even the implied warranty of
> +#   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
> +#   GNU General Public License for more details.
> +#
> +#   You should have received a copy of the GNU General Public License
> +#   along with this program.  If not, see <http://www.gnu.org/licenses/>.
> +#
> +
> +[[ -n "$LIBMAKEPKG_LINT_CONFIG_SH" ]] && return
> +LIBMAKEPKG_LINT_CONFIG_SH=1
> +
> +LIBRARY=${LIBRARY:-'/usr/share/makepkg'}
> +
> +source "$LIBRARY/util/message.sh"
> +source "$LIBRARY/util/util.sh"
> +
> +
> +declare -a lint_config_functions
> +
> +for lib in "$LIBRARY/lint_config/"*.sh; do
> + source "$lib"
> +done
> +
> +readonly -a lint_config_functions
> +
> +
> +lint_package() {

lint_config()

which makes me suspect this is not tested...

(rest of patch looks fine though)

A
Reply | Threaded
Open this post in threaded view
|

Re: [PATCH] libmakepkg: Add basic rules to lint makepkg.conf variables

Eli Schwartz-2
On 03/08/2018 10:06 PM, Allan McRae wrote:
> lint_config()
>
> which makes me suspect this is not tested...
>
> (rest of patch looks fine though)

I have that fixed locally but forgot to resubmit. Also
libmakepkg/lint_config/variables.sh should be
libmakepkg/lint_config/variable.sh


--
Eli Schwartz
Bug Wrangler and Trusted User


signature.asc (849 bytes) Download Attachment
Reply | Threaded
Open this post in threaded view
|

[PATCH] libmakepkg: Add basic rules to lint makepkg.conf variables

Eli Schwartz-2
In reply to this post by Eli Schwartz-2
Currently the only things we check are:

- Things that should be arrays, are not strings, and vice versa (this
  was mostly copy-pasted from the similar code in lint_pkgbuild).
- Variables that are meant to contain pathname components cannot contain
  a newline character, because newline characters in pathnames are weird
  and also don't play well with future changes intended for the
  --packagelist option.

Signed-off-by: Eli Schwartz <[hidden email]>
---

v2: Fix a couple typos.

 scripts/Makefile.am                           |  4 ++
 scripts/libmakepkg/lint_config.sh.in          | 48 ++++++++++++++++++++
 scripts/libmakepkg/lint_config/paths.sh.in    | 46 +++++++++++++++++++
 scripts/libmakepkg/lint_config/variable.sh.in | 64 +++++++++++++++++++++++++++
 scripts/makepkg.sh.in                         |  4 ++
 5 files changed, 166 insertions(+)
 create mode 100755 scripts/libmakepkg/lint_config.sh.in
 create mode 100644 scripts/libmakepkg/lint_config/paths.sh.in
 create mode 100644 scripts/libmakepkg/lint_config/variable.sh.in

diff --git a/scripts/Makefile.am b/scripts/Makefile.am
index 8cf79f21..7fe169b3 100644
--- a/scripts/Makefile.am
+++ b/scripts/Makefile.am
@@ -44,6 +44,7 @@ libmakepkgdir = $(datarootdir)/makepkg
 
 LIBMAKEPKGDIRS = \
  integrity \
+ lint_config \
  lint_package \
  lint_pkgbuild \
  source \
@@ -56,6 +57,9 @@ LIBMAKEPKG_IN = \
  libmakepkg/integrity/generate_signature.sh \
  libmakepkg/integrity/verify_checksum.sh \
  libmakepkg/integrity/verify_signature.sh \
+ libmakepkg/lint_config.sh \
+ libmakepkg/lint_config/paths.sh \
+ libmakepkg/lint_config/variable.sh \
  libmakepkg/lint_package.sh \
  libmakepkg/lint_package/build_references.sh \
  libmakepkg/lint_package/dotfiles.sh \
diff --git a/scripts/libmakepkg/lint_config.sh.in b/scripts/libmakepkg/lint_config.sh.in
new file mode 100755
index 00000000..6a76d7bb
--- /dev/null
+++ b/scripts/libmakepkg/lint_config.sh.in
@@ -0,0 +1,48 @@
+#!/usr/bin/bash
+#
+#   lint_config.sh - functions for checking for makepkg.conf errors
+#
+#   Copyright (c) 2018 Pacman Development Team <[hidden email]>
+#
+#   This program is free software; you can redistribute it and/or modify
+#   it under the terms of the GNU General Public License as published by
+#   the Free Software Foundation; either version 2 of the License, or
+#   (at your option) any later version.
+#
+#   This program is distributed in the hope that it will be useful,
+#   but WITHOUT ANY WARRANTY; without even the implied warranty of
+#   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+#   GNU General Public License for more details.
+#
+#   You should have received a copy of the GNU General Public License
+#   along with this program.  If not, see <http://www.gnu.org/licenses/>.
+#
+
+[[ -n "$LIBMAKEPKG_LINT_CONFIG_SH" ]] && return
+LIBMAKEPKG_LINT_CONFIG_SH=1
+
+LIBRARY=${LIBRARY:-'/usr/share/makepkg'}
+
+source "$LIBRARY/util/message.sh"
+source "$LIBRARY/util/util.sh"
+
+
+declare -a lint_config_functions
+
+for lib in "$LIBRARY/lint_config/"*.sh; do
+ source "$lib"
+done
+
+readonly -a lint_config_functions
+
+
+lint_config() {
+ cd_safe "$pkgdir"
+ msg "$(gettext "Checking for makepkg.conf issues...")"
+
+ local ret=0
+ for func in ${lint_config_functions[@]}; do
+ $func || ret=1
+ done
+ return $ret
+}
diff --git a/scripts/libmakepkg/lint_config/paths.sh.in b/scripts/libmakepkg/lint_config/paths.sh.in
new file mode 100644
index 00000000..c75765ff
--- /dev/null
+++ b/scripts/libmakepkg/lint_config/paths.sh.in
@@ -0,0 +1,46 @@
+#!/bin/bash
+#
+#   paths.sh - Check that pathname components do not contain odd characters
+#
+#   Copyright (c) 2018 Pacman Development Team <[hidden email]>
+#
+#   This program is free software; you can redistribute it and/or modify
+#   it under the terms of the GNU General Public License as published by
+#   the Free Software Foundation; either version 2 of the License, or
+#   (at your option) any later version.
+#
+#   This program is distributed in the hope that it will be useful,
+#   but WITHOUT ANY WARRANTY; without even the implied warranty of
+#   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+#   GNU General Public License for more details.
+#
+#   You should have received a copy of the GNU General Public License
+#   along with this program.  If not, see <http://www.gnu.org/licenses/>.
+#
+
+[[ -n "$LIBMAKEPKG_LINT_CONFIG_PATHS_SH" ]] && return
+LIBMAKEPKG_LINT_CONFIG_PATHS_SH=1
+
+LIBRARY=${LIBRARY:-'@libmakepkgdir@'}
+
+source "$LIBRARY/util/message.sh"
+source "$LIBRARY/util/pkgbuild.sh"
+
+lint_config_functions+=('lint_variable')
+
+
+lint_paths() {
+ local pathvars=(BUILDDIR PKGDEST SRCDEST SRCPKGDEST LOGDEST PKGEXT SRCEXT)
+
+ local i ret=0
+
+ for i in ${pathvars[@]}; do
+ if [[ ${!i} = *$'\n'* ]]; then
+ error "$(gettext "%s contains invalid characters: '%s'")" \
+ "$i" "${!i//[^$'\n']}"
+ ret=1
+ fi
+ done
+
+ return $ret
+}
diff --git a/scripts/libmakepkg/lint_config/variable.sh.in b/scripts/libmakepkg/lint_config/variable.sh.in
new file mode 100644
index 00000000..14bd0e05
--- /dev/null
+++ b/scripts/libmakepkg/lint_config/variable.sh.in
@@ -0,0 +1,64 @@
+#!/bin/bash
+#
+#   variable.sh - Check that variables are or are not arrays as appropriate
+#
+#   Copyright (c) 2018 Pacman Development Team <[hidden email]>
+#
+#   This program is free software; you can redistribute it and/or modify
+#   it under the terms of the GNU General Public License as published by
+#   the Free Software Foundation; either version 2 of the License, or
+#   (at your option) any later version.
+#
+#   This program is distributed in the hope that it will be useful,
+#   but WITHOUT ANY WARRANTY; without even the implied warranty of
+#   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+#   GNU General Public License for more details.
+#
+#   You should have received a copy of the GNU General Public License
+#   along with this program.  If not, see <http://www.gnu.org/licenses/>.
+#
+
+[[ -n "$LIBMAKEPKG_LINT_CONFIG_VARIABLE_SH" ]] && return
+LIBMAKEPKG_LINT_CONFIG_VARIABLE_SH=1
+
+LIBRARY=${LIBRARY:-'@libmakepkgdir@'}
+
+source "$LIBRARY/util/message.sh"
+
+lint_config_functions+=('lint_variable')
+
+
+lint_variable() {
+ local array=(DLAGENTS VCSCLIENTS BUILDENV OPTIONS INTEGRITY_CHECK MAN_DIRS
+             DOC_DIRS PURGE_TARGETS COMPRESSGZ COMPRESSBZ2 COMPRESSXZ
+             COMPRESSLRZ COMPRESSLZO COMPRESSZ)
+ local string=(CARCH CHOST CPPFLAGS CFLAGS CXXFLAGS LDFLAGS DEBUG_CFLAGS
+              DEBUG_CXXFLAGS DISTCC_HOSTS BUILDDIR STRIP_BINARIES STRIP_SHARED
+              STRIP_STATIC PKGDEST SRCDEST SRCPKGDEST LOGDEST PACKAGER GPGKEY
+              PKGEXT SRCEXT)
+
+ local i keys ret=0
+
+ # global variables
+ for i in ${array[@]}; do
+ eval "keys=(\"\${!$i[@]}\")"
+ if (( ${#keys[*]} > 0 )); then
+ if ! is_array $i; then
+ error "$(gettext "%s should be an array")" "$i"
+ ret=1
+ fi
+ fi
+ done
+
+ for i in ${string[@]}; do
+ eval "keys=(\"\${!$i[@]}\")"
+ if (( ${#keys[*]} > 0 )); then
+ if is_array $i; then
+ error "$(gettext "%s should not be an array")" "$i"
+ ret=1
+ fi
+ fi
+ done
+
+ return $ret
+}
diff --git a/scripts/makepkg.sh.in b/scripts/makepkg.sh.in
index a22bcce2..f0703d41 100644
--- a/scripts/makepkg.sh.in
+++ b/scripts/makepkg.sh.in
@@ -1361,6 +1361,10 @@ else
 fi
 
 
+# check makepkg.conf for some basic requirements
+lint_config || exit $E_CONFIG_ERROR
+
+
 # check that all settings directories are user-writable
 if ! ensure_writable_dir "BUILDDIR" "$BUILDDIR"; then
  plain "$(gettext "Aborting...")"
--
2.16.2
Reply | Threaded
Open this post in threaded view
|

[PATCH] libmakepkg: Add basic rules to lint makepkg.conf variables

Eli Schwartz-2
In reply to this post by Eli Schwartz-2
Currently the only things we check are:

- Things that should be arrays, are not strings, and vice versa (this
  was mostly copy-pasted from the similar code in lint_pkgbuild).
- Variables that are meant to contain pathname components cannot contain
  a newline character, because newline characters in pathnames are weird
  and also don't play well with future changes intended for the
  --packagelist option.

Signed-off-by: Eli Schwartz <[hidden email]>
---

v3: rm useless logging message

 scripts/Makefile.am                           |  4 ++
 scripts/libmakepkg/lint_config.sh.in          | 46 +++++++++++++++++++
 scripts/libmakepkg/lint_config/paths.sh.in    | 46 +++++++++++++++++++
 scripts/libmakepkg/lint_config/variable.sh.in | 64 +++++++++++++++++++++++++++
 scripts/makepkg.sh.in                         |  4 ++
 5 files changed, 164 insertions(+)
 create mode 100755 scripts/libmakepkg/lint_config.sh.in
 create mode 100644 scripts/libmakepkg/lint_config/paths.sh.in
 create mode 100644 scripts/libmakepkg/lint_config/variable.sh.in

diff --git a/scripts/Makefile.am b/scripts/Makefile.am
index 8cf79f21..7fe169b3 100644
--- a/scripts/Makefile.am
+++ b/scripts/Makefile.am
@@ -44,6 +44,7 @@ libmakepkgdir = $(datarootdir)/makepkg
 
 LIBMAKEPKGDIRS = \
  integrity \
+ lint_config \
  lint_package \
  lint_pkgbuild \
  source \
@@ -56,6 +57,9 @@ LIBMAKEPKG_IN = \
  libmakepkg/integrity/generate_signature.sh \
  libmakepkg/integrity/verify_checksum.sh \
  libmakepkg/integrity/verify_signature.sh \
+ libmakepkg/lint_config.sh \
+ libmakepkg/lint_config/paths.sh \
+ libmakepkg/lint_config/variable.sh \
  libmakepkg/lint_package.sh \
  libmakepkg/lint_package/build_references.sh \
  libmakepkg/lint_package/dotfiles.sh \
diff --git a/scripts/libmakepkg/lint_config.sh.in b/scripts/libmakepkg/lint_config.sh.in
new file mode 100755
index 00000000..bad68bcb
--- /dev/null
+++ b/scripts/libmakepkg/lint_config.sh.in
@@ -0,0 +1,46 @@
+#!/usr/bin/bash
+#
+#   lint_config.sh - functions for checking for makepkg.conf errors
+#
+#   Copyright (c) 2018 Pacman Development Team <[hidden email]>
+#
+#   This program is free software; you can redistribute it and/or modify
+#   it under the terms of the GNU General Public License as published by
+#   the Free Software Foundation; either version 2 of the License, or
+#   (at your option) any later version.
+#
+#   This program is distributed in the hope that it will be useful,
+#   but WITHOUT ANY WARRANTY; without even the implied warranty of
+#   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+#   GNU General Public License for more details.
+#
+#   You should have received a copy of the GNU General Public License
+#   along with this program.  If not, see <http://www.gnu.org/licenses/>.
+#
+
+[[ -n "$LIBMAKEPKG_LINT_CONFIG_SH" ]] && return
+LIBMAKEPKG_LINT_CONFIG_SH=1
+
+LIBRARY=${LIBRARY:-'/usr/share/makepkg'}
+
+source "$LIBRARY/util/message.sh"
+source "$LIBRARY/util/util.sh"
+
+
+declare -a lint_config_functions
+
+for lib in "$LIBRARY/lint_config/"*.sh; do
+ source "$lib"
+done
+
+readonly -a lint_config_functions
+
+
+lint_config() {
+ local ret=0
+
+ for func in ${lint_config_functions[@]}; do
+ $func || ret=1
+ done
+ return $ret
+}
diff --git a/scripts/libmakepkg/lint_config/paths.sh.in b/scripts/libmakepkg/lint_config/paths.sh.in
new file mode 100644
index 00000000..c75765ff
--- /dev/null
+++ b/scripts/libmakepkg/lint_config/paths.sh.in
@@ -0,0 +1,46 @@
+#!/bin/bash
+#
+#   paths.sh - Check that pathname components do not contain odd characters
+#
+#   Copyright (c) 2018 Pacman Development Team <[hidden email]>
+#
+#   This program is free software; you can redistribute it and/or modify
+#   it under the terms of the GNU General Public License as published by
+#   the Free Software Foundation; either version 2 of the License, or
+#   (at your option) any later version.
+#
+#   This program is distributed in the hope that it will be useful,
+#   but WITHOUT ANY WARRANTY; without even the implied warranty of
+#   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+#   GNU General Public License for more details.
+#
+#   You should have received a copy of the GNU General Public License
+#   along with this program.  If not, see <http://www.gnu.org/licenses/>.
+#
+
+[[ -n "$LIBMAKEPKG_LINT_CONFIG_PATHS_SH" ]] && return
+LIBMAKEPKG_LINT_CONFIG_PATHS_SH=1
+
+LIBRARY=${LIBRARY:-'@libmakepkgdir@'}
+
+source "$LIBRARY/util/message.sh"
+source "$LIBRARY/util/pkgbuild.sh"
+
+lint_config_functions+=('lint_variable')
+
+
+lint_paths() {
+ local pathvars=(BUILDDIR PKGDEST SRCDEST SRCPKGDEST LOGDEST PKGEXT SRCEXT)
+
+ local i ret=0
+
+ for i in ${pathvars[@]}; do
+ if [[ ${!i} = *$'\n'* ]]; then
+ error "$(gettext "%s contains invalid characters: '%s'")" \
+ "$i" "${!i//[^$'\n']}"
+ ret=1
+ fi
+ done
+
+ return $ret
+}
diff --git a/scripts/libmakepkg/lint_config/variable.sh.in b/scripts/libmakepkg/lint_config/variable.sh.in
new file mode 100644
index 00000000..14bd0e05
--- /dev/null
+++ b/scripts/libmakepkg/lint_config/variable.sh.in
@@ -0,0 +1,64 @@
+#!/bin/bash
+#
+#   variable.sh - Check that variables are or are not arrays as appropriate
+#
+#   Copyright (c) 2018 Pacman Development Team <[hidden email]>
+#
+#   This program is free software; you can redistribute it and/or modify
+#   it under the terms of the GNU General Public License as published by
+#   the Free Software Foundation; either version 2 of the License, or
+#   (at your option) any later version.
+#
+#   This program is distributed in the hope that it will be useful,
+#   but WITHOUT ANY WARRANTY; without even the implied warranty of
+#   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+#   GNU General Public License for more details.
+#
+#   You should have received a copy of the GNU General Public License
+#   along with this program.  If not, see <http://www.gnu.org/licenses/>.
+#
+
+[[ -n "$LIBMAKEPKG_LINT_CONFIG_VARIABLE_SH" ]] && return
+LIBMAKEPKG_LINT_CONFIG_VARIABLE_SH=1
+
+LIBRARY=${LIBRARY:-'@libmakepkgdir@'}
+
+source "$LIBRARY/util/message.sh"
+
+lint_config_functions+=('lint_variable')
+
+
+lint_variable() {
+ local array=(DLAGENTS VCSCLIENTS BUILDENV OPTIONS INTEGRITY_CHECK MAN_DIRS
+             DOC_DIRS PURGE_TARGETS COMPRESSGZ COMPRESSBZ2 COMPRESSXZ
+             COMPRESSLRZ COMPRESSLZO COMPRESSZ)
+ local string=(CARCH CHOST CPPFLAGS CFLAGS CXXFLAGS LDFLAGS DEBUG_CFLAGS
+              DEBUG_CXXFLAGS DISTCC_HOSTS BUILDDIR STRIP_BINARIES STRIP_SHARED
+              STRIP_STATIC PKGDEST SRCDEST SRCPKGDEST LOGDEST PACKAGER GPGKEY
+              PKGEXT SRCEXT)
+
+ local i keys ret=0
+
+ # global variables
+ for i in ${array[@]}; do
+ eval "keys=(\"\${!$i[@]}\")"
+ if (( ${#keys[*]} > 0 )); then
+ if ! is_array $i; then
+ error "$(gettext "%s should be an array")" "$i"
+ ret=1
+ fi
+ fi
+ done
+
+ for i in ${string[@]}; do
+ eval "keys=(\"\${!$i[@]}\")"
+ if (( ${#keys[*]} > 0 )); then
+ if is_array $i; then
+ error "$(gettext "%s should not be an array")" "$i"
+ ret=1
+ fi
+ fi
+ done
+
+ return $ret
+}
diff --git a/scripts/makepkg.sh.in b/scripts/makepkg.sh.in
index a22bcce2..f0703d41 100644
--- a/scripts/makepkg.sh.in
+++ b/scripts/makepkg.sh.in
@@ -1361,6 +1361,10 @@ else
 fi
 
 
+# check makepkg.conf for some basic requirements
+lint_config || exit $E_CONFIG_ERROR
+
+
 # check that all settings directories are user-writable
 if ! ensure_writable_dir "BUILDDIR" "$BUILDDIR"; then
  plain "$(gettext "Aborting...")"
--
2.16.2
Reply | Threaded
Open this post in threaded view
|

Re: [PATCH] libmakepkg: Add basic rules to lint makepkg.conf variables

Allan McRae
On 09/03/18 13:47, Eli Schwartz wrote:

> Currently the only things we check are:
>
> - Things that should be arrays, are not strings, and vice versa (this
>   was mostly copy-pasted from the similar code in lint_pkgbuild).
> - Variables that are meant to contain pathname components cannot contain
>   a newline character, because newline characters in pathnames are weird
>   and also don't play well with future changes intended for the
>   --packagelist option.
>
> Signed-off-by: Eli Schwartz <[hidden email]>
> ---
>
> v3: rm useless logging message
>
>  scripts/Makefile.am                           |  4 ++
>  scripts/libmakepkg/lint_config.sh.in          | 46 +++++++++++++++++++
>  scripts/libmakepkg/lint_config/paths.sh.in    | 46 +++++++++++++++++++
>  scripts/libmakepkg/lint_config/variable.sh.in | 64 +++++++++++++++++++++++++++
>  scripts/makepkg.sh.in                         |  4 ++
>  5 files changed, 164 insertions(+)
>  create mode 100755 scripts/libmakepkg/lint_config.sh.in
>  create mode 100644 scripts/libmakepkg/lint_config/paths.sh.in
>  create mode 100644 scripts/libmakepkg/lint_config/variable.sh.in
>
> diff --git a/scripts/Makefile.am b/scripts/Makefile.am
> index 8cf79f21..7fe169b3 100644
> --- a/scripts/Makefile.am
> +++ b/scripts/Makefile.am
> @@ -44,6 +44,7 @@ libmakepkgdir = $(datarootdir)/makepkg
>  
>  LIBMAKEPKGDIRS = \
>   integrity \
> + lint_config \
>   lint_package \
>   lint_pkgbuild \
>   source \
> @@ -56,6 +57,9 @@ LIBMAKEPKG_IN = \
>   libmakepkg/integrity/generate_signature.sh \
>   libmakepkg/integrity/verify_checksum.sh \
>   libmakepkg/integrity/verify_signature.sh \
> + libmakepkg/lint_config.sh \
> + libmakepkg/lint_config/paths.sh \
> + libmakepkg/lint_config/variable.sh \
>   libmakepkg/lint_package.sh \
>   libmakepkg/lint_package/build_references.sh \
>   libmakepkg/lint_package/dotfiles.sh \
> diff --git a/scripts/libmakepkg/lint_config.sh.in b/scripts/libmakepkg/lint_config.sh.in
> new file mode 100755
> index 00000000..bad68bcb
> --- /dev/null
> +++ b/scripts/libmakepkg/lint_config.sh.in
> @@ -0,0 +1,46 @@
> +#!/usr/bin/bash
> +#
> +#   lint_config.sh - functions for checking for makepkg.conf errors
> +#
> +#   Copyright (c) 2018 Pacman Development Team <[hidden email]>
> +#
> +#   This program is free software; you can redistribute it and/or modify
> +#   it under the terms of the GNU General Public License as published by
> +#   the Free Software Foundation; either version 2 of the License, or
> +#   (at your option) any later version.
> +#
> +#   This program is distributed in the hope that it will be useful,
> +#   but WITHOUT ANY WARRANTY; without even the implied warranty of
> +#   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
> +#   GNU General Public License for more details.
> +#
> +#   You should have received a copy of the GNU General Public License
> +#   along with this program.  If not, see <http://www.gnu.org/licenses/>.
> +#
> +
> +[[ -n "$LIBMAKEPKG_LINT_CONFIG_SH" ]] && return
> +LIBMAKEPKG_LINT_CONFIG_SH=1
> +
> +LIBRARY=${LIBRARY:-'/usr/share/makepkg'}
> +
> +source "$LIBRARY/util/message.sh"
> +source "$LIBRARY/util/util.sh"
> +
> +
> +declare -a lint_config_functions
> +
> +for lib in "$LIBRARY/lint_config/"*.sh; do
> + source "$lib"
> +done
> +
> +readonly -a lint_config_functions
> +
> +
> +lint_config() {
> + local ret=0
> +
> + for func in ${lint_config_functions[@]}; do
> + $func || ret=1
> + done
> + return $ret
> +}
> diff --git a/scripts/libmakepkg/lint_config/paths.sh.in b/scripts/libmakepkg/lint_config/paths.sh.in
> new file mode 100644
> index 00000000..c75765ff
> --- /dev/null
> +++ b/scripts/libmakepkg/lint_config/paths.sh.in
> @@ -0,0 +1,46 @@
> +#!/bin/bash
> +#
> +#   paths.sh - Check that pathname components do not contain odd characters
> +#
> +#   Copyright (c) 2018 Pacman Development Team <[hidden email]>
> +#
> +#   This program is free software; you can redistribute it and/or modify
> +#   it under the terms of the GNU General Public License as published by
> +#   the Free Software Foundation; either version 2 of the License, or
> +#   (at your option) any later version.
> +#
> +#   This program is distributed in the hope that it will be useful,
> +#   but WITHOUT ANY WARRANTY; without even the implied warranty of
> +#   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
> +#   GNU General Public License for more details.
> +#
> +#   You should have received a copy of the GNU General Public License
> +#   along with this program.  If not, see <http://www.gnu.org/licenses/>.
> +#
> +
> +[[ -n "$LIBMAKEPKG_LINT_CONFIG_PATHS_SH" ]] && return
> +LIBMAKEPKG_LINT_CONFIG_PATHS_SH=1
> +
> +LIBRARY=${LIBRARY:-'@libmakepkgdir@'}
> +
> +source "$LIBRARY/util/message.sh"
> +source "$LIBRARY/util/pkgbuild.sh"
> +
> +lint_config_functions+=('lint_variable')

s/lint_variable/lint_paths/

> +
> +
> +lint_paths() {
> + local pathvars=(BUILDDIR PKGDEST SRCDEST SRCPKGDEST LOGDEST PKGEXT SRCEXT)
> +

Because of that error, none of these checks work...   So another great
bit of testing before submission!

A
Reply | Threaded
Open this post in threaded view
|

[PATCH v4] libmakepkg: Add basic rules to lint makepkg.conf variables

Eli Schwartz-2
In reply to this post by Eli Schwartz-2
Currently the only things we check are:

- Things that should be arrays, are not strings, and vice versa (this
  was mostly copy-pasted from the similar code in lint_pkgbuild).
- Variables that are meant to contain pathname components cannot contain
  a newline character, because newline characters in pathnames are weird
  and also don't play well with future changes intended for the
  --packagelist option.

Signed-off-by: Eli Schwartz <[hidden email]>
---

v4: fixed another typo in paths.sh

 scripts/Makefile.am                           |  4 ++
 scripts/libmakepkg/lint_config.sh.in          | 46 +++++++++++++++++++
 scripts/libmakepkg/lint_config/paths.sh.in    | 46 +++++++++++++++++++
 scripts/libmakepkg/lint_config/variable.sh.in | 64 +++++++++++++++++++++++++++
 scripts/makepkg.sh.in                         |  4 ++
 5 files changed, 164 insertions(+)
 create mode 100755 scripts/libmakepkg/lint_config.sh.in
 create mode 100644 scripts/libmakepkg/lint_config/paths.sh.in
 create mode 100644 scripts/libmakepkg/lint_config/variable.sh.in

diff --git a/scripts/Makefile.am b/scripts/Makefile.am
index 8cf79f21..7fe169b3 100644
--- a/scripts/Makefile.am
+++ b/scripts/Makefile.am
@@ -44,6 +44,7 @@ libmakepkgdir = $(datarootdir)/makepkg
 
 LIBMAKEPKGDIRS = \
  integrity \
+ lint_config \
  lint_package \
  lint_pkgbuild \
  source \
@@ -56,6 +57,9 @@ LIBMAKEPKG_IN = \
  libmakepkg/integrity/generate_signature.sh \
  libmakepkg/integrity/verify_checksum.sh \
  libmakepkg/integrity/verify_signature.sh \
+ libmakepkg/lint_config.sh \
+ libmakepkg/lint_config/paths.sh \
+ libmakepkg/lint_config/variable.sh \
  libmakepkg/lint_package.sh \
  libmakepkg/lint_package/build_references.sh \
  libmakepkg/lint_package/dotfiles.sh \
diff --git a/scripts/libmakepkg/lint_config.sh.in b/scripts/libmakepkg/lint_config.sh.in
new file mode 100755
index 00000000..bad68bcb
--- /dev/null
+++ b/scripts/libmakepkg/lint_config.sh.in
@@ -0,0 +1,46 @@
+#!/usr/bin/bash
+#
+#   lint_config.sh - functions for checking for makepkg.conf errors
+#
+#   Copyright (c) 2018 Pacman Development Team <[hidden email]>
+#
+#   This program is free software; you can redistribute it and/or modify
+#   it under the terms of the GNU General Public License as published by
+#   the Free Software Foundation; either version 2 of the License, or
+#   (at your option) any later version.
+#
+#   This program is distributed in the hope that it will be useful,
+#   but WITHOUT ANY WARRANTY; without even the implied warranty of
+#   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+#   GNU General Public License for more details.
+#
+#   You should have received a copy of the GNU General Public License
+#   along with this program.  If not, see <http://www.gnu.org/licenses/>.
+#
+
+[[ -n "$LIBMAKEPKG_LINT_CONFIG_SH" ]] && return
+LIBMAKEPKG_LINT_CONFIG_SH=1
+
+LIBRARY=${LIBRARY:-'/usr/share/makepkg'}
+
+source "$LIBRARY/util/message.sh"
+source "$LIBRARY/util/util.sh"
+
+
+declare -a lint_config_functions
+
+for lib in "$LIBRARY/lint_config/"*.sh; do
+ source "$lib"
+done
+
+readonly -a lint_config_functions
+
+
+lint_config() {
+ local ret=0
+
+ for func in ${lint_config_functions[@]}; do
+ $func || ret=1
+ done
+ return $ret
+}
diff --git a/scripts/libmakepkg/lint_config/paths.sh.in b/scripts/libmakepkg/lint_config/paths.sh.in
new file mode 100644
index 00000000..95630b58
--- /dev/null
+++ b/scripts/libmakepkg/lint_config/paths.sh.in
@@ -0,0 +1,46 @@
+#!/bin/bash
+#
+#   paths.sh - Check that pathname components do not contain odd characters
+#
+#   Copyright (c) 2018 Pacman Development Team <[hidden email]>
+#
+#   This program is free software; you can redistribute it and/or modify
+#   it under the terms of the GNU General Public License as published by
+#   the Free Software Foundation; either version 2 of the License, or
+#   (at your option) any later version.
+#
+#   This program is distributed in the hope that it will be useful,
+#   but WITHOUT ANY WARRANTY; without even the implied warranty of
+#   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+#   GNU General Public License for more details.
+#
+#   You should have received a copy of the GNU General Public License
+#   along with this program.  If not, see <http://www.gnu.org/licenses/>.
+#
+
+[[ -n "$LIBMAKEPKG_LINT_CONFIG_PATHS_SH" ]] && return
+LIBMAKEPKG_LINT_CONFIG_PATHS_SH=1
+
+LIBRARY=${LIBRARY:-'@libmakepkgdir@'}
+
+source "$LIBRARY/util/message.sh"
+source "$LIBRARY/util/pkgbuild.sh"
+
+lint_config_functions+=('lint_paths')
+
+
+lint_paths() {
+ local pathvars=(BUILDDIR PKGDEST SRCDEST SRCPKGDEST LOGDEST PKGEXT SRCEXT)
+
+ local i ret=0
+
+ for i in ${pathvars[@]}; do
+ if [[ ${!i} = *$'\n'* ]]; then
+ error "$(gettext "%s contains invalid characters: '%s'")" \
+ "$i" "${!i//[^$'\n']}"
+ ret=1
+ fi
+ done
+
+ return $ret
+}
diff --git a/scripts/libmakepkg/lint_config/variable.sh.in b/scripts/libmakepkg/lint_config/variable.sh.in
new file mode 100644
index 00000000..14bd0e05
--- /dev/null
+++ b/scripts/libmakepkg/lint_config/variable.sh.in
@@ -0,0 +1,64 @@
+#!/bin/bash
+#
+#   variable.sh - Check that variables are or are not arrays as appropriate
+#
+#   Copyright (c) 2018 Pacman Development Team <[hidden email]>
+#
+#   This program is free software; you can redistribute it and/or modify
+#   it under the terms of the GNU General Public License as published by
+#   the Free Software Foundation; either version 2 of the License, or
+#   (at your option) any later version.
+#
+#   This program is distributed in the hope that it will be useful,
+#   but WITHOUT ANY WARRANTY; without even the implied warranty of
+#   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+#   GNU General Public License for more details.
+#
+#   You should have received a copy of the GNU General Public License
+#   along with this program.  If not, see <http://www.gnu.org/licenses/>.
+#
+
+[[ -n "$LIBMAKEPKG_LINT_CONFIG_VARIABLE_SH" ]] && return
+LIBMAKEPKG_LINT_CONFIG_VARIABLE_SH=1
+
+LIBRARY=${LIBRARY:-'@libmakepkgdir@'}
+
+source "$LIBRARY/util/message.sh"
+
+lint_config_functions+=('lint_variable')
+
+
+lint_variable() {
+ local array=(DLAGENTS VCSCLIENTS BUILDENV OPTIONS INTEGRITY_CHECK MAN_DIRS
+             DOC_DIRS PURGE_TARGETS COMPRESSGZ COMPRESSBZ2 COMPRESSXZ
+             COMPRESSLRZ COMPRESSLZO COMPRESSZ)
+ local string=(CARCH CHOST CPPFLAGS CFLAGS CXXFLAGS LDFLAGS DEBUG_CFLAGS
+              DEBUG_CXXFLAGS DISTCC_HOSTS BUILDDIR STRIP_BINARIES STRIP_SHARED
+              STRIP_STATIC PKGDEST SRCDEST SRCPKGDEST LOGDEST PACKAGER GPGKEY
+              PKGEXT SRCEXT)
+
+ local i keys ret=0
+
+ # global variables
+ for i in ${array[@]}; do
+ eval "keys=(\"\${!$i[@]}\")"
+ if (( ${#keys[*]} > 0 )); then
+ if ! is_array $i; then
+ error "$(gettext "%s should be an array")" "$i"
+ ret=1
+ fi
+ fi
+ done
+
+ for i in ${string[@]}; do
+ eval "keys=(\"\${!$i[@]}\")"
+ if (( ${#keys[*]} > 0 )); then
+ if is_array $i; then
+ error "$(gettext "%s should not be an array")" "$i"
+ ret=1
+ fi
+ fi
+ done
+
+ return $ret
+}
diff --git a/scripts/makepkg.sh.in b/scripts/makepkg.sh.in
index 0eed620c..96a96483 100644
--- a/scripts/makepkg.sh.in
+++ b/scripts/makepkg.sh.in
@@ -1365,6 +1365,10 @@ else
 fi
 
 
+# check makepkg.conf for some basic requirements
+lint_config || exit $E_CONFIG_ERROR
+
+
 # check that all settings directories are user-writable
 if ! ensure_writable_dir "BUILDDIR" "$BUILDDIR"; then
  plain "$(gettext "Aborting...")"
--
2.16.2